/**
* @file duty_cycle.c
*
* Copyright (c) 2004 Atmel.
*
* @brief ̧قͼэL͈͂̌`Ԑݒɱ邽߂ɑSĂ̿ ̧قɂĊ
*		 ߂܂B
*
* @version 1.0 (CVS revision : 1.3)
* @date 2006/02/02 16:30:28 (created on 06/04/2004)
* @author raubree (created by Emmanuel David)

*****************************************************************************/

#include "config.h"

#include "table_sin120.h"			/* table_sin120.h : 3gȂ */
//#include "table_sin120b.h"		/* table_sin120b.h : 3gL */

#define		MAX_SIN			128		// 3gȂ̏ꍇ
//#define	MAX_SIN			110		// 3gL̏ꍇ

#define		MAX_THETA		120		// /2
#define		MAX_THETAx2		240
#define		MAX_THETAx3		360
#define		MAX_THETAx4		480
#define		MAX_PWM			2666

/****************************************************************************/
/*					ޭè 												*/
/****************************************************************************/
/*!
 * ̊֐PWMޭè قvZ܂B:
 * - sin()vẐɐ\p܂B
 * - (V/fė)VmɂďZ
 * - ƕ̓d𐶐邽߂MAX_PWM/2ɂĈړ
 * - 1/4\Ɋi[܂B
*/

U16 duty_cycle(U16 theta, U16 Vm)
{
  signed char	sinus ;
  S32			Vmxsin ;

  if (theta <= MAX_THETA)						// 0/2ł̃
	sinus = tab_sin[theta];						// sin()
  else
  {
	if (theta <= MAX_THETAx2)					// /2΂ł̃
	  sinus = tab_sin[MAX_THETAx2-theta];		// sin(-)
	else
	{
	  if (theta<=MAX_THETAx3)					// ΂3/2ł̃
		sinus = - tab_sin[theta-MAX_THETAx2];	// sin(-)
	  else										// 3/22΂ł̃
		sinus = - tab_sin[MAX_THETAx4-theta];	// sin(2-)
	}
  }
  Vmxsin = sinus;
  Vmxsin = (Vmxsin * Vm)/MAX_SIN ;
  return ((unsigned int) (MAX_PWM/2 + Vmxsin));
}
